<?php
    /**
     * Convert RDF from one format to another
     *
     * The source RDF data can either be fetched from the web
     * or typed into the Input box.
     *
     * The first thing that this script does is make a list the names of the
     * supported input and output formats. These options are then
     * displayed on the HTML form.
     *
     * The input data is loaded or parsed into an EasyRdf_Graph.
     * That graph is than outputted again in the desired output format.
     *
     * @package    EasyRdf
     * @copyright  Copyright (c) 2009-2013 Nicholas J Humfrey
     * @license    http://unlicense.org/
     */

    set_include_path(get_include_path() . PATH_SEPARATOR . '../lib/');
    require_once "EasyRdf.php";
    require_once "html_tag_helpers.php";

    $input_format_options = array('Guess' => 'guess');
    $output_format_options = array();
    foreach (EasyRdf_Format::getFormats() as $format) {
        if ($format->getSerialiserClass()) {
            $output_format_options[$format->getLabel()] = $format->getName();
        }
        if ($format->getParserClass()) {
            $input_format_options[$format->getLabel()] = $format->getName();
        }
    }

    // Stupid PHP :(
    if (get_magic_quotes_gpc() and isset($_REQUEST['rdfData'])) {
        $_REQUEST['rdfData'] = stripslashes($_REQUEST['rdfData']);
    }



    //if (isset($_REQUEST['uri']) or isset($_REQUEST['data'])) {
        // Parse the input
        $graph = new EasyRdf_Graph('http://www.dajobe.org/foaf.rdf');
        if (empty($_REQUEST['rdfData'])) {
            $graph->load('http://www.dajobe.org/foaf.rdf', 'rdfxml');
        } else {
            $graph->parse($_REQUEST['rdfData'], $_REQUEST['radio'], 'http://www.dajobe.org/foaf.rdf');
        }

        // Lookup the output format
        $format = EasyRdf_Format::getFormat('ntriples');

        // Serialise to the new output format
        $output = $graph->serialise($format);
        if (!is_scalar($output)) {
            $output = var_export($output, true);
        }

        // Send the output back to the client
        //if (isset($_REQUEST['raw'])) {
            //header('Content-Type: '.$format->getDefaultMimeType());
            //print $output;
        //} else {
		echo json_encode($graph->getArray());
            //print '<pre>'.htmlspecialchars($output).'</pre>';
        //}
    //}

    //if (!isset($_REQUEST['raw'])) {
        //print "</body>\n";
        //print "</html>\n";
    //}
