//Copyright (c) 2015 Artur Smaroń
//
//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:
//
//
//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.
//
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.


joint.shapes.rdf = {};

joint.shapes.rdf.SquereObject = joint.dia.Element.extend({

    markup: '<g class="rotatable">'
                +' <g class="">'
                
                + '<g class = "selectionFrame" display="">'
                + '<rect class="selectionSquare"/>'
                + '</g>'
				+ '<rect class="root"/>'
                + '</g><text class="text_value"/>'
                +' </g>',

    defaults: joint.util.deepSupplement({

        type: 'rdf.SquereObject',
        size: { width: 112, height: 62 },
        attrs: {

            '.selectionSquare' :{
                width: 114, height: 64, ref: '.root', 'ref-x': -7, 'ref-y': -7, stroke: '#444444', 'stroke-width': 1, fill: 'transparent',
                'stroke-dasharray': '5 3'
            },

            '.root': {
                fill: 'white',
                stroke: '#000000', 'stroke-width': 2,
                'pointer-events': 'visiblePainted',
                magnet: 'passive', width: 100, height: 50
            },

            '.text_value': {
                ref: '.root', 'ref-x': .5, 'ref-y': .55,
                'font-family': 'Times, serif', 'font-size': 14,
                'text-anchor': 'middle', 'y-alignment': 'middle', fill: '#3333CC'
            },
        },
        rdftype: ''

    }, joint.dia.Element.prototype.defaults)
});

joint.shapes.rdf.OvalObject = joint.dia.Element.extend({

    markup: '<g class="rotatable">'
                +' <g class="">'
                + '<ellipse class="root"/>'
                + '<g class = "selectionFrame" display="">'
                + '<rect class="selectionSquare"/>'
                + '</g>'
                + '</g><text class="text_value"/>'
                +' </g>',

    defaults: joint.util.deepSupplement({

        type: 'rdf.OvalObject',
        size: { width: 110, height: 60 },
        attrs: {

            '.selectionSquare' :{
                width: 110, height: 60, ref: '.root', 'ref-x': -5, 'ref-y': -5, stroke: '#444444', 'stroke-width': 1, fill: 'transparent',
                'stroke-dasharray': '5 3'
            },

            '.root': {
                fill: 'white',
                stroke: '#000000', 'stroke-width': 2,
                'pointer-events': 'visiblePainted',
                magnet: 'passive', rx: 50, ry: 25
            },

            '.text_value': {
                ref: '.root', 'ref-x': .5, 'ref-y': .53,
                'font-family': 'Times, serif', 'font-size': 14,
                'text-anchor': 'middle', 'y-alignment': 'middle', fill: '#3333CC'
            },
        },

    }, joint.dia.Element.prototype.defaults)
});

joint.shapes.rdf.BlankObject = joint.dia.Element.extend({

    markup: '<g class="rotatable">'
                +' <g class="">'
                + '<ellipse class="root"/>'
                + '<g class = "selectionFrame" display="">'
                + '<rect class="selectionSquare"/>'
                + '</g>'
                + '</g><text class="text_value"/>'
                +' </g>',

    defaults: joint.util.deepSupplement({

        type: 'rdf.BlankObject',
        size: { width: 110, height: 60 },
        attrs: {

            '.selectionSquare' :{
                width: 110, height: 60, ref: '.root', 'ref-x': -5, 'ref-y': -5, stroke: '#444444', 'stroke-width': 1, fill: 'transparent',
                'stroke-dasharray': '5 3'
            },

            '.root': {
                fill: 'white',
                stroke: '#000000', 'stroke-width': 2,
                'pointer-events': 'visiblePainted',
                magnet: 'passive', rx: 50, ry: 25
            },

            '.text_value': {
                ref: '.root', 'ref-x': .5, 'ref-y': .53,
                'font-family': 'Times, serif', 'font-size': 14,
                'text-anchor': 'middle', 'y-alignment': 'middle', fill: '#3333CC'
            },
        },

    }, joint.dia.Element.prototype.defaults)
});

joint.shapes.rdf.UriArrow = joint.dia.Link.extend({

	markup: [
        '<path class="connection" stroke="black" fill="transparent"/>',
        '<path class="marker-source" fill="black" stroke="black" />',
        '<path class="marker-target" fill="black" stroke="black" />',
        '<path class="connection-wrap" fill="transparent"/>',
		'<g class = "selectionFrame" display="">',
		'<rect class="selectionSquare"/>',
		'</g>',
        '<g class="labels"/>',
        '<g class="marker-vertices"/>',
        '<g class="marker-arrowheads"/>',
        '<g class="link-tools"/>'
    ].join(''),
	
    arrowheadMarkup: [
        '<g class="marker-arrowhead-group marker-arrowhead-group-<%= end %>">',
        '<circle class="marker-arrowhead" end="<%= end %>" r="10" fill="transparent"/>',
        '</g>'
    ].join(''),

    vertexMarkup: [
        '<g class="marker-vertex-group" transform="translate(<%= x %>, <%= y %>)">',
        '<circle class="marker-vertex" idx="<%= idx %>" r="10" fill="transparent"/>',
        '<g class="marker-vertex-remove-group">',
        '<path fill="transparent" class="marker-vertex-remove-area" idx="<%= idx %>" d="M16,5.333c-7.732,0-14,4.701-14,10.5c0,1.982,0.741,3.833,2.016,5.414L2,25.667l5.613-1.441c2.339,1.317,5.237,2.107,8.387,2.107c7.732,0,14-4.701,14-10.5C30,10.034,23.732,5.333,16,5.333z" transform="translate(5, -33)"/>',
        '<path fill="transparent" class="marker-vertex-remove" idx="<%= idx %>" transform="scale(.8) translate(9.5, -37)" d="M24.778,21.419 19.276,15.917 24.777,10.415 21.949,7.585 16.447,13.087 10.945,7.585 8.117,10.415 13.618,15.917 8.116,21.419 10.946,24.248 16.447,18.746 21.948,24.248z">',
        '<title>Remove vertex.</title>',
        '</path>',
        '</g>',
        '</g>'
    ].join(''),

    toolMarkup: [
       '<g class="link-tool">',
       '<g class="tool-options" event="link:options">',
       '<circle r="11" transform="translate(25)" fill="transparent"/>',
       '<path fill="transparent" transform="scale(.55) translate(29, -16)" d="M31.229,17.736c0.064-0.571,0.104-1.148,0.104-1.736s-0.04-1.166-0.104-1.737l-4.377-1.557c-0.218-0.716-0.504-1.401-0.851-2.05l1.993-4.192c-0.725-0.91-1.549-1.734-2.458-2.459l-4.193,1.994c-0.647-0.347-1.334-0.632-2.049-0.849l-1.558-4.378C17.165,0.708,16.588,0.667,16,0.667s-1.166,0.041-1.737,0.105L12.707,5.15c-0.716,0.217-1.401,0.502-2.05,0.849L6.464,4.005C5.554,4.73,4.73,5.554,4.005,6.464l1.994,4.192c-0.347,0.648-0.632,1.334-0.849,2.05l-4.378,1.557C0.708,14.834,0.667,15.412,0.667,16s0.041,1.165,0.105,1.736l4.378,1.558c0.217,0.715,0.502,1.401,0.849,2.049l-1.994,4.193c0.725,0.909,1.549,1.733,2.459,2.458l4.192-1.993c0.648,0.347,1.334,0.633,2.05,0.851l1.557,4.377c0.571,0.064,1.148,0.104,1.737,0.104c0.588,0,1.165-0.04,1.736-0.104l1.558-4.377c0.715-0.218,1.399-0.504,2.049-0.851l4.193,1.993c0.909-0.725,1.733-1.549,2.458-2.458l-1.993-4.193c0.347-0.647,0.633-1.334,0.851-2.049L31.229,17.736zM16,20.871c-2.69,0-4.872-2.182-4.872-4.871c0-2.69,2.182-4.872,4.872-4.872c2.689,0,4.871,2.182,4.871,4.872C20.871,18.689,18.689,20.871,16,20.871z"/>',
       '<title>Link options.</title>',
       '</g>',
       '</g>'
    ].join(''),

    defaults: joint.util.deepSupplement({
	
		smooth: true,
        type: 'rdf.UriArrow',
        //router: { name: 'orthogonal' },
        //router: { name: 'manhattan' },
        //connector: { name: 'rounded', args: { radius: 10 } },
        attrs: {
			'.selectionSquare' :{
                width: 110, height: 60, ref: '.connection', 'ref-x': -5, 'ref-y': -5, stroke: '#444444', 'stroke-width': 1, fill: 'transparent',
                'stroke-dasharray': '5 3', 'pointer-events': 'visiblePainted'
            },
            '.connection': { 'stroke-width': 2, fill: 'transparent', stroke: '#006B00'},
            '.marker-vertex': { r: 5, },
            '.marker-target':
                { d: 'M 15 -2 L 0 5 L 15 12 L 5 z M5 5 L10 5', fill: '#006B00', stroke: '#006B00', opacity: '1' },
        },
		labels: [
			{ position: .5, attrs: { text: { text: 'label', fill: '#CC0000', 'font-family': 'Times, serif', 'font-size': 14 } }}
		]

    }, joint.dia.Link.prototype.defaults)
});

if (typeof exports === 'object') {

    module.exports = joint.shapes.rdf;
}
